/**BitReverseal.cpp
On va définir la méthode de calcul par décomposition binaire
**/

#include "Divers.h"
#include "Complexe.h"

void FFTB(Complexe Coef[], float ListeR[], int N)
{
    for (int i = 0 ; i<N ; i++)
    {
        Coef[i].setRe(ListeR[i]);
    }

    int m = N/2;
    int a,b;
    Complexe tmp;

    while(m>=1)
    {
        Complexe z,w;
        z.setRe(1);
        w.setExp(1,-PI/m);
        for(int k = 1; k<=m; k++)
        {
            for(int h = 1 ; h<=N/(2*m); h++)
            {
                    a = k+2*(h-1)*m;
                    b = a+m;
                    tmp = (Coef[a-1] - Coef[b-1])*z;
                    Coef[a-1] = Coef[a-1] + Coef[b-1];
                    Coef[b-1] = tmp;
            }

            z = z*w;
        }

        m = m/2;
    }

    b = 1;

    for(int a = 1 ; a<=N; a++)
    {
            if(b>a)
            {
                tmp = Coef[b-1];
                Coef[b-1] = Coef[a-1];
                Coef[a-1] = tmp;
            }

            m = N/2;

            while (m>=2 && b>m)
            {
                b = b-m;
                m = m/2;
            }

            b += m;
    }

}
